Page MenuHomePhabricator

New selection concept: "Select Node"-Dialog
Closed, ResolvedPublic

Description

We are developing a new local selection concept that can be used inside the MITK plugins. It aims to replace the QmitkDataStorageComboBox, as the data storage combo box does not offer enough flexibility.
We decided to go with a “local selection“ concept, as this gives more control for the individual plugins and clearly separates the responsibilities of managing data nodes for visualization purposes and managing data nodes for algorithm processing.

We propose to create a BaseSelection widget, which could be used in a “select plugin node“ dialog, that pops up after clicking a button of a plugin. This widget could contain several tabs that provide different approaches to select nodes. This could go from a simple list, similar to the data manager view through a sorted patient view to a semantic relation matrix, which we offer for the BlackSwan-project. And each developer should be able to easily subclass and extend
/ modify an approach to customize the behavior for the current need.
This BaseSelection widget could offer different selection approaches by using the registered node-selectionservices. This would allow each module to add its custom node-selection-service to MITK. An interface has to define functions and variables that are needed for each node-selection-service. The BaseSelection widget just relies on the node-selection-service interface and puts each service into its own tab.

Event Timeline

kalali created this task.Aug 24 2017, 4:54 PM
kalali created subtask Restricted Maniphest Task.Aug 24 2017, 4:58 PM
kalali lowered the priority of this task from High to Normal.Aug 25 2017, 11:30 AM

If the fully generalized new selection concept has been established, it can be used in the Segmentation Plugin and in the Registration Plugin (MatchPoint). Those plugins are frequently used in the BlackSwan Workflow.

kalali added a comment.EditedNov 9 2017, 4:50 PM

Other Plugins, that rely on image node selection:

plugin nameselection mechanismnote
SegmentationQmitkDataStorageComboBox2 Combo boxes: 1 with an image-predicate, 1 with a segmentation-predicate
Segmentation UtilitiesQmitkDataStorageComboBoxseveral mixed combo boxes (with image-predicates / with segmentation-predicates)
Clipping PlaneQmitkDataStorageComboBox1 combo box with a "clipping plane"-property predicate
ClassificationSegmentationQmitkDataStorageComboBox
MultiLabelQmitkDataStorageComboBox2 Combo boxes: 1 with an image-predicate, 1 with a segmentation-predicate
MultiLabel UtilitiesQmitkDataStorageComboBox
BasicImageProcessingQmitkDataStorageComboBox
MatchPoint ...QmitkDataStorageComboBox
MatchPoint ...QmitkDataStorageComboBox
MatchPoint ...QmitkDataStorageComboBox
BasicImageProcessingDataManager selection
MeasurementDataManager selection
StatisticsDataManager selection
Dicom InspectorDataManager selection
PropertiesDataManager selectionuse function OnSelectionChanged from AbstractView
PointSet InteractionDataManager selectionuse function GetDataManagerSelection
kalali changed the visibility from "Restricted Project (Project)" to "Public (No Login Required)".
kalali changed the edit policy from "Restricted Project (Project)" to "All Users".
kalali added a project: MITK.
floca closed this task as Resolved.May 15 2018, 12:27 PM
kalali moved this task from Restricted Project Column to Restricted Project Column on the Restricted Project board.Jun 11 2018, 11:20 AM
kalali closed subtask Restricted Maniphest Task as Resolved.Jun 14 2018, 2:14 PM